Loading...
Searching...
No Matches
juce::AudioProcessorGraph Class Reference

## Detailed Description

A type of AudioProcessor which plays back a graph of other AudioProcessors.

Use one of these objects if you want to wire-up a set of AudioProcessors and play back the result.

Processors can be added to the graph as "nodes" using addNode(), and once added, you can connect any of their input or output channels to other nodes using addConnection().

To play back a graph through an audio device, you might want to use an AudioProcessorPlayer object.

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/processors/juce_AudioProcessorGraph.h

Inheritance diagram for juce::AudioProcessorGraph:

## Classes

struct | NodeID
| Each node in the graph has a UID of this type. More...
class | NodeAndChannel
| Represents an input or output channel of a node in an AudioProcessorGraph. More...
class | Node
| Represents one of the nodes, or processors, in an AudioProcessorGraph. More...
struct | Connection
| Represents a connection between two channels of two nodes in an AudioProcessorGraph. More...
class | AudioGraphIOProcessor
| A special type of AudioProcessor that can live inside an AudioProcessorGraph in order to use the audio that comes into and out of the graph itself. More...

## Public Types

enum | { midiChannelIndex = 0x1000 }
| A special index that represents the midi channel of a node. More...
enum class | UpdateKind { sync , async , none }
| Indicates how the graph should be updated after a change. More...
Public Types inherited from juce::AudioProcessor
enum | ProcessingPrecision { singlePrecision , doublePrecision }
enum class | Realtime { no , yes }
enum | WrapperType { wrapperType_Undefined = 0 , wrapperType_VST , wrapperType_VST3 , wrapperType_AudioUnit , wrapperType_AudioUnitv3 , wrapperType_AAX , wrapperType_Standalone , wrapperType_Unity , wrapperType_LV2 }
| Flags to indicate the type of plugin context in which a processor is being used. More...
using | ChangeDetails = AudioProcessorListener::ChangeDetails

## Public Member Functions

| AudioProcessorGraph ()
| Creates an empty graph.
| ~AudioProcessorGraph () override
| Destructor.
void | clear (UpdateKind=UpdateKind::sync)
| Deletes all nodes and connections from this graph.
const ReferenceCountedArray< Node > & | getNodes () const noexcept
| Returns the array of nodes in the graph.
int | getNumNodes () const noexcept
| Returns the number of nodes in the graph.
Node::Ptr | getNode (int index) const noexcept
| Returns a pointer to one of the nodes in the graph.
Node * | getNodeForId (NodeID) const
| Searches the graph for a node with the given ID number and returns it.
Node::Ptr | addNode (std::unique_ptr< AudioProcessor > newProcessor, std::optional< NodeID > nodeId=std::nullopt, UpdateKind=UpdateKind::sync)
| Adds a node to the graph.
Node::Ptr | removeNode (NodeID, UpdateKind=UpdateKind::sync)
| Deletes a node within the graph which has the specified ID.
Node::Ptr | removeNode (Node *, UpdateKind=UpdateKind::sync)
| Deletes a node within the graph.
std::vector< Connection > | getConnections () const
| Returns the list of connections in the graph.
bool | isConnected (const Connection &) const noexcept
| Returns true if the given connection exists.
bool | isConnected (NodeID possibleSourceNodeID, NodeID possibleDestNodeID) const noexcept
| Returns true if there is a direct connection between any of the channels of two specified nodes.
bool | isAnInputTo (const Node &source, const Node &destination) const noexcept
| Does a recursive check to see if there's a direct or indirect series of connections between these two nodes.
bool | isAnInputTo (NodeID source, NodeID destination) const noexcept
| Does a recursive check to see if there's a direct or indirect series of connections between these two nodes.
bool | canConnect (const Connection &) const
| Returns true if it would be legal to connect the specified points.
bool | addConnection (const Connection &, UpdateKind=UpdateKind::sync)
| Attempts to connect two specified channels of two nodes.
bool | removeConnection (const Connection &, UpdateKind=UpdateKind::sync)
| Deletes the given connection.
bool | disconnectNode (NodeID, UpdateKind=UpdateKind::sync)
| Removes all connections from the specified node.
bool | isConnectionLegal (const Connection &) const
| Returns true if the given connection's channel numbers map on to valid channels at each end.
bool | removeIllegalConnections (UpdateKind=UpdateKind::sync)
| Performs a sanity checks of all the connections.
void | rebuild ()
| Rebuilds the graph if necessary.
const String | getName () const override
| Returns the name of this processor.
void | prepareToPlay (double, int) override
| Called before playback starts, to let the processor prepare itself.
void | releaseResources () override
| Called after playback has stopped, to let the object free up any resources it no longer needs.
void | processBlock (AudioBuffer< float > &, MidiBuffer &) override
| Renders the next block.
void | processBlock (AudioBuffer< double > &, MidiBuffer &) override
| Renders the next block.
bool | supportsDoublePrecisionProcessing () const override
| Returns true if the Audio processor supports double precision floating point processing.
void | reset () override
| A plugin can override this to be told when it should reset any playing voices.
void | setNonRealtime (bool) noexcept override
| Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing.
double | getTailLengthSeconds () const override
| Returns the length of the processor's tail, in seconds.
bool | acceptsMidi () const override
| Returns true if the processor wants MIDI messages.
bool | producesMidi () const override
| Returns true if the processor produces MIDI messages.
bool | hasEditor () const override
| Your processor subclass must override this and return true if it can create an editor component.
AudioProcessorEditor * | createEditor () override
| Creates the processor's GUI.
int | getNumPrograms () override
| Returns the number of preset programs the processor supports.
int | getCurrentProgram () override
| Returns the number of the currently active program.
void | setCurrentProgram (int) override
| Called by the host to change the current program.
const String | getProgramName (int) override
| Must return the name of a given program.
void | changeProgramName (int, const String &) override
| Called by the host to rename a program.
void | getStateInformation (juce::MemoryBlock &) override
| The host will call this method when it wants to save the processor's internal state.
void | setStateInformation (const void *data, int sizeInBytes) override
| This must restore the processor's state from a block of data previously created using getStateInformation().
Public Member Functions inherited from juce::AudioProcessor
virtual | ~AudioProcessor ()
| Destructor.
virtual StringArray | getAlternateDisplayNames () const
| Returns a list of alternative names to use for this processor.
virtual void | memoryWarningReceived ()
| Called by the host to indicate that you should reduce your memory footprint.
virtual void | processBlockBypassed (AudioBuffer< float > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed.
virtual void | processBlockBypassed (AudioBuffer< double > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed.
int | getBusCount (bool isInput) const noexcept
| Returns the number of buses on the input or output side.
Bus * | getBus (bool isInput, int busIndex) noexcept
| Returns the audio bus with a given index and direction.
const Bus * | getBus (bool isInput, int busIndex) const noexcept
| Returns the audio bus with a given index and direction.
virtual bool | canAddBus (bool isInput) const
| Callback to query if a bus can currently be added.
virtual bool | canRemoveBus (bool isInput) const
| Callback to query if the last bus can currently be removed.
bool | addBus (bool isInput)
| Dynamically request an additional bus.
bool | removeBus (bool isInput)
| Dynamically remove the latest added bus.
bool | setBusesLayout (const BusesLayout &)
| Set the channel layouts of this audio processor.
bool | setBusesLayoutWithoutEnabling (const BusesLayout &)
| Set the channel layouts of this audio processor without changing the enablement state of the buses.
BusesLayout | getBusesLayout () const
| Provides the current channel layouts of this audio processor.
AudioChannelSet | getChannelLayoutOfBus (bool isInput, int busIndex) const noexcept
| Provides the channel layout of the bus with a given index and direction.
bool | setChannelLayoutOfBus (bool isInput, int busIndex, const AudioChannelSet &layout)
| Set the channel layout of the bus with a given index and direction.
int | getChannelCountOfBus (bool isInput, int busIndex) const noexcept
| Provides the number of channels of the bus with a given index and direction.
bool | enableAllBuses ()
| Enables all buses.
bool | disableNonMainBuses ()
| Disables all non-main buses (aux and sidechains).
int | getChannelIndexInProcessBlockBuffer (bool isInput, int busIndex, int channelIndex) const noexcept
| Returns the position of a bus's channels within the processBlock buffer.
int | getOffsetInBusBufferForAbsoluteChannelIndex (bool isInput, int absoluteChannelIndex, int &busIndex) const noexcept
| Returns the offset in a bus's buffer from an absolute channel index.
template<typename FloatType>
AudioBuffer< FloatType > | getBusBuffer (AudioBuffer< FloatType > &processBlockBuffer, bool isInput, int busIndex) const
| Returns an AudioBuffer containing a set of channel pointers for a specific bus.
bool | checkBusesLayoutSupported (const BusesLayout &) const
| Returns true if the Audio processor is likely to support a given layout.
ProcessingPrecision | getProcessingPrecision () const noexcept
| Returns the precision-mode of the processor.
bool | isUsingDoublePrecision () const noexcept
| Returns true if the current precision is set to doublePrecision.
void | setProcessingPrecision (ProcessingPrecision newPrecision) noexcept
| Changes the processing precision of the receiver.
AudioPlayHead * | getPlayHead () const noexcept
| Returns the current AudioPlayHead object that should be used to find out the state and position of the playhead.
int | getTotalNumInputChannels () const noexcept
| Returns the total number of input channels.
int | getTotalNumOutputChannels () const noexcept
| Returns the total number of output channels.
int | getMainBusNumInputChannels () const noexcept
| Returns the number of input channels on the main bus.
int | getMainBusNumOutputChannels () const noexcept
| Returns the number of output channels on the main bus.
template<size_t numLayouts>
BusesLayout | getNextBestLayoutInLayoutList (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
| Returns the next best layout which is contained in a channel layout map.
double | getSampleRate () const noexcept
| Returns the current sample rate.
int | getBlockSize () const noexcept
| Returns the current typical block size that is being used.
int | getLatencySamples () const noexcept
| This returns the number of samples delay that the processor imposes on the audio passing through it.
void | setLatencySamples (int newLatency)
| Your processor subclass should call this to set the number of samples delay that it introduces.
virtual bool | supportsMPE () const
| Returns true if the processor supports MPE.
virtual bool | isMidiEffect () const
| Returns true if this is a MIDI effect plug-in and does no audio processing.
const CriticalSection & | getCallbackLock () const noexcept
| This returns a critical section that will automatically be locked while the host is calling the processBlock() method.
void | suspendProcessing (bool shouldBeSuspended)
| Enables and disables the processing callback.
bool | isSuspended () const noexcept
| Returns true if processing is currently suspended.
virtual AudioProcessorParameter * | getBypassParameter () const
| Returns the parameter that controls the AudioProcessor's bypass state.
bool | isNonRealtime () const noexcept
| Returns true if the processor is being run in an offline mode for rendering.
Realtime | isRealtime () const noexcept
| Returns no if the processor is being run in an offline mode for rendering.
AudioProcessorEditor * | getActiveEditor () const noexcept
| Returns the active editor, if there is one.
AudioProcessorEditor * | createEditorIfNeeded ()
| Returns the active editor, or if there isn't one, it will create one.
void | updateHostDisplay (const ChangeDetails &details=ChangeDetails::getDefaultFlags())
| The processor can call this when something (apart from a parameter value) has changed.
void | addParameter (AudioProcessorParameter *)
| Adds a parameter to the AudioProcessor.
void | addParameterGroup (std::unique_ptr< AudioProcessorParameterGroup >)
| Adds a group of parameters to the AudioProcessor.
const AudioProcessorParameterGroup & | getParameterTree () const
| Returns the group of parameters managed by this AudioProcessor.
void | setParameterTree (AudioProcessorParameterGroup &&newTree)
| Sets the group of parameters managed by this AudioProcessor.
virtual void | refreshParameterList ()
| A processor should implement this method so that the host can ask it to rebuild its parameter tree.
const Array< AudioProcessorParameter * > & | getParameters () const
| Returns a flat list of the parameters in the current tree.
virtual void | getCurrentProgramStateInformation (MemoryBlock &destData)
| The host will call this method if it wants to save the state of just the processor's current program.
virtual void | setCurrentProgramStateInformation (const void *data, int sizeInBytes)
| The host will call this method if it wants to restore the state of just the processor's current program.
virtual void | numChannelsChanged ()
| This method is called when the total number of input or output channels is changed.
virtual void | numBusesChanged ()
| This method is called when the number of buses is changed.
virtual void | processorLayoutsChanged ()
| This method is called when the layout of the audio processor changes.
virtual void | addListener (AudioProcessorListener *newListener)
| Adds a listener that will be called when an aspect of this processor changes.
virtual void | removeListener (AudioProcessorListener *listenerToRemove)
| Removes a previously added listener.
virtual void | setPlayHead (AudioPlayHead *newPlayHead)
| Tells the processor to use this playhead object.
void | setPlayConfigDetails (int numIns, int numOuts, double sampleRate, int blockSize)
| This is called by the processor to specify its details before being played.
void | setRateAndBufferSizeDetails (double sampleRate, int blockSize) noexcept
| This is called by the processor to specify its details before being played.
virtual void | audioWorkgroupContextChanged (const AudioWorkgroup &workgroup)
| This is called by the host when the thread workgroup context has changed.
virtual AAXClientExtensions & | getAAXClientExtensions ()
| Returns a reference to an object that implements AAX specific information regarding this AudioProcessor.
virtual VST2ClientExtensions * | getVST2ClientExtensions ()
| Returns a non-owning pointer to an object that implements VST2 specific information regarding this AudioProcessor.
virtual VST3ClientExtensions * | getVST3ClientExtensions ()
| Returns a non-owning pointer to an object that implements VST3 specific information regarding this AudioProcessor.
virtual CurveData | getResponseCurve (CurveData::Type) const
void | editorBeingDeleted (AudioProcessorEditor *) noexcept
| Not for public use - this is called before deleting an editor component.
virtual void | updateTrackProperties (const TrackProperties &properties)
| Informs the AudioProcessor that track properties such as the track's name or colour has been changed.
virtual std::optional< String > | getNameForMidiNoteNumber (int note, int midiChannel)
| Returns a custom name for a MIDI note number.
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster.
virtual | ~ChangeBroadcaster ()
| Destructor.
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster.
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list.
void | removeAllChangeListeners ()
| Removes all listeners from the list.
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners.
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners.
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately.

## Additional Inherited Members

Static Public Member Functions inherited from juce::AudioProcessor
static bool | containsLayout (const BusesLayout &layouts, const std::initializer_list< const short[2]> &channelLayoutList)
| Returns true if the channel layout map contains a certain layout.
template<size_t numLayouts>
static bool | containsLayout (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter.
static const char * | getWrapperTypeDescription (AudioProcessor::WrapperType) noexcept
| Returns a textual description of a WrapperType value.
static void | copyXmlToBinary (const XmlElement &xml, MemoryBlock &destData)
| Helper function that just converts an xml element into a binary blob.
static std::unique_ptr< XmlElement > | getXmlFromBinary (const void *data, int sizeInBytes)
| Retrieves an XML element that was stored as binary with the copyXmlToBinary() method.
static void JUCE_CALLTYPE | setTypeOfNextNewPlugin (WrapperType)
Public Attributes inherited from juce::AudioProcessor
const WrapperType | wrapperType
| When loaded by a plugin wrapper, this flag will be set to indicate the type of plugin within which the processor is running.
Protected Member Functions inherited from juce::AudioProcessor
| AudioProcessor ()
| Constructor.
| AudioProcessor (const BusesProperties &ioLayouts)
| Constructor for multi-bus AudioProcessors.
| AudioProcessor (const std::initializer_list< const short[2]> &channelLayoutList)
| Constructor for AudioProcessors which use layout maps If your AudioProcessor uses layout maps then use this constructor.
virtual bool | isBusesLayoutSupported (const BusesLayout &) const
| Callback to query if the AudioProcessor supports a specific layout.
virtual bool | canApplyBusesLayout (const BusesLayout &layouts) const
| Callback to check if a certain bus layout can now be applied.
virtual bool | applyBusLayouts (const BusesLayout &layouts)
| This method will be called when a new bus layout needs to be applied.
virtual bool | canApplyBusCountChange (bool isInput, bool isAddingBuses, BusProperties &outNewBusProperties)
| Callback to query if adding/removing buses currently possible.
Protected Attributes inherited from juce::AudioProcessor
std::atomic< AudioPlayHead * > | playHead { nullptr }

## Member Enums

## anonymous enum

anonymous enum

A special index that represents the midi channel of a node.

This is used as a channel index value if you want to refer to the midi input or output instead of an audio channel.

Enumerator
midiChannelIndex |

## UpdateKind

enum class juce::AudioProcessorGraph::UpdateKind

strong

Indicates how the graph should be updated after a change.

If you need to make lots of changes to a graph (e.g. lots of separate calls to addNode, addConnection etc.) you can avoid rebuilding the graph on each change by using the async update kind.

Enumerator
sync | Graph should be rebuilt immediately after modification.
async | Graph rebuild should be delayed. If you make several changes to the graph inside the same call stack, these changes will be applied in one go.
none | Graph should not be rebuilt automatically. Use rebuild() to trigger a graph rebuild.

## Constructors and Destructors

## AudioProcessorGraph()

juce::AudioProcessorGraph::AudioProcessorGraph | ( |  | ) |

Creates an empty graph.

Referenced by juce::AudioProcessorGraph::AudioGraphIOProcessor::getParentGraph(), juce::AudioProcessorGraph::AudioGraphIOProcessor::setParentGraph(), and setStateInformation().

## ~AudioProcessorGraph()

juce::AudioProcessorGraph::~AudioProcessorGraph | ( |  | ) |

override

Destructor.

Any processor objects that have been added to the graph will also be deleted.

## Member Functions

## clear()

void juce::AudioProcessorGraph::clear | ( | UpdateKind | = UpdateKind::sync | ) |

Deletes all nodes and connections from this graph.

Any processor objects in the graph will be deleted.

References sync.

## getNodes()

const ReferenceCountedArray< Node > & juce::AudioProcessorGraph::getNodes | ( |  | ) | const

noexcept

Returns the array of nodes in the graph.

Referenced by getNode(), and getNumNodes().

## getNumNodes()

int juce::AudioProcessorGraph::getNumNodes | ( |  | ) | const

inline noexcept

Returns the number of nodes in the graph.

References getNodes(), and getNumNodes().

Referenced by getNumNodes().

## getNode()

Node::Ptr juce::AudioProcessorGraph::getNode | ( | int | index | ) | const

inline noexcept

Returns a pointer to one of the nodes in the graph.

This will return nullptr if the index is out of range.

See also
  getNodeForId

References getNodes().

## getNodeForId()

Node * juce::AudioProcessorGraph::getNodeForId | ( | NodeID |  | ) | const

Searches the graph for a node with the given ID number and returns it.

If no such node was found, this returns nullptr.

See also
  getNode

## addNode()

Node::Ptr juce::AudioProcessorGraph::addNode | ( | std::unique_ptr< AudioProcessor > | newProcessor,
|  | std::optional< NodeID > | nodeId = std::nullopt,
|  | UpdateKind | = UpdateKind::sync )

Adds a node to the graph.

This creates a new node in the graph, for the specified processor. Once you have added a processor to the graph, the graph owns it and will delete it later when it is no longer needed.

The optional nodeId parameter lets you specify a unique ID to use for the node. If the value is already in use, this method will fail and return an empty node.

If this succeeds, it returns a pointer to the newly-created node.

References sync.

## removeNode() [1/2]

Node::Ptr juce::AudioProcessorGraph::removeNode | ( | NodeID | ,
|  | UpdateKind | = UpdateKind::sync )

Deletes a node within the graph which has the specified ID.

This will also delete any connections that are attached to this node.

References sync.

## removeNode() [2/2]

Node::Ptr juce::AudioProcessorGraph::removeNode | ( | Node * | ,
|  | UpdateKind | = UpdateKind::sync )

Deletes a node within the graph.

This will also delete any connections that are attached to this node.

References sync.

## getConnections()

std::vector< Connection > juce::AudioProcessorGraph::getConnections | ( |  | ) | const

Returns the list of connections in the graph.

## isConnected() [1/2]

bool juce::AudioProcessorGraph::isConnected | ( | const Connection & |  | ) | const

noexcept

Returns true if the given connection exists.

## isConnected() [2/2]

bool juce::AudioProcessorGraph::isConnected | ( | NodeID | possibleSourceNodeID,
|  | NodeID | possibleDestNodeID ) const

noexcept

Returns true if there is a direct connection between any of the channels of two specified nodes.

## isAnInputTo() [1/2]

bool juce::AudioProcessorGraph::isAnInputTo | ( | const Node & | source,
|  | const Node & | destination ) const

noexcept

Does a recursive check to see if there's a direct or indirect series of connections between these two nodes.

## isAnInputTo() [2/2]

bool juce::AudioProcessorGraph::isAnInputTo | ( | NodeID | source,
|  | NodeID | destination ) const

noexcept

Does a recursive check to see if there's a direct or indirect series of connections between these two nodes.

## canConnect()

bool juce::AudioProcessorGraph::canConnect | ( | const Connection & |  | ) | const

Returns true if it would be legal to connect the specified points.

## addConnection()

bool juce::AudioProcessorGraph::addConnection | ( | const Connection & | ,
|  | UpdateKind | = UpdateKind::sync )

Attempts to connect two specified channels of two nodes.

If this isn't allowed (e.g. because you're trying to connect a midi channel to an audio one or other such nonsense), then it'll return false.

References sync.

## removeConnection()

bool juce::AudioProcessorGraph::removeConnection | ( | const Connection & | ,
|  | UpdateKind | = UpdateKind::sync )

Deletes the given connection.

References sync.

## disconnectNode()

bool juce::AudioProcessorGraph::disconnectNode | ( | NodeID | ,
|  | UpdateKind | = UpdateKind::sync )

Removes all connections from the specified node.

References sync.

## isConnectionLegal()

bool juce::AudioProcessorGraph::isConnectionLegal | ( | const Connection & |  | ) | const

Returns true if the given connection's channel numbers map on to valid channels at each end.

Even if a connection is valid when created, its status could change if a node changes its channel config.

## removeIllegalConnections()

bool juce::AudioProcessorGraph::removeIllegalConnections | ( | UpdateKind | = UpdateKind::sync | ) |

Performs a sanity checks of all the connections.

This might be useful if some of the processors are doing things like changing their channel counts, which could render some connections obsolete.

References sync.

## rebuild()

void juce::AudioProcessorGraph::rebuild | ( |  | ) |

Rebuilds the graph if necessary.

This function will only ever rebuild the graph on the main thread. If this function is called from another thread, the rebuild request will be dispatched asynchronously to the main thread.

## getName()

const String juce::AudioProcessorGraph::getName | ( |  | ) | const

override virtual

Returns the name of this processor.

Implements juce::AudioProcessor.

References getName().

Referenced by getName().

## prepareToPlay()

void juce::AudioProcessorGraph::prepareToPlay | ( | double | sampleRate,
|  | int | maximumExpectedSamplesPerBlock )

override virtual

Called before playback starts, to let the processor prepare itself.

The sample rate is the target sample rate, and will remain constant until playback stops.

You can call getTotalNumInputChannels and getTotalNumOutputChannels or query the busLayout member variable to find out the number of channels your processBlock callback must process.

The maximumExpectedSamplesPerBlock value is a strong hint about the maximum number of samples that will be provided in each block. You may want to use this value to resize internal buffers. You should program defensively in case a buggy host exceeds this value. The actual block sizes that the host uses may be different each time the callback happens: completely variable block sizes can be expected from some hosts.

See also
  busLayout, getTotalNumInputChannels, getTotalNumOutputChannels

Implements juce::AudioProcessor.

References prepareToPlay().

Referenced by prepareToPlay().

## releaseResources()

void juce::AudioProcessorGraph::releaseResources | ( |  | ) |

override virtual

Called after playback has stopped, to let the object free up any resources it no longer needs.

Implements juce::AudioProcessor.

References releaseResources().

Referenced by releaseResources().

## processBlock() [1/2]

void juce::AudioProcessorGraph::processBlock | ( | AudioBuffer< float > & | buffer,
|  | MidiBuffer & | midiMessages )

override virtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has a total of 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain an audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Implements juce::AudioProcessor.

References processBlock().

Referenced by processBlock(), and processBlock().

## processBlock() [2/2]

void juce::AudioProcessorGraph::processBlock | ( | AudioBuffer< double > & | buffer,
|  | MidiBuffer & | midiMessages )

override virtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a combined total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain a audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

If your plugin uses buses, then you should use getBusBuffer() or getChannelIndexInProcessBlockBuffer() to find out which of the input and output channels correspond to which of the buses.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Reimplemented from juce::AudioProcessor.

References processBlock().

## supportsDoublePrecisionProcessing()

bool juce::AudioProcessorGraph::supportsDoublePrecisionProcessing | ( |  | ) | const

override virtual

Returns true if the Audio processor supports double precision floating point processing.

The default implementation will always return false. If you return true here then you must override the double precision versions of processBlock. Additionally, you must call getProcessingPrecision() in your prepareToPlay method to determine the precision with which you need to allocate your internal buffers.

See also
  getProcessingPrecision, setProcessingPrecision

Reimplemented from juce::AudioProcessor.

References supportsDoublePrecisionProcessing().

Referenced by supportsDoublePrecisionProcessing().

## reset()

void juce::AudioProcessorGraph::reset | ( |  | ) |

override virtual

A plugin can override this to be told when it should reset any playing voices.

The default implementation does nothing, but a host may call this to tell the plugin that it should stop any tails or sounds that have been left running.

Reimplemented from juce::AudioProcessor.

References reset().

Referenced by reset().

## setNonRealtime()

void juce::AudioProcessorGraph::setNonRealtime | ( | bool | isNonRealtime | ) |

override virtual noexcept

Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing.

Reimplemented from juce::AudioProcessor.

References setNonRealtime().

Referenced by setNonRealtime().

## getTailLengthSeconds()

double juce::AudioProcessorGraph::getTailLengthSeconds | ( |  | ) | const

override virtual

Returns the length of the processor's tail, in seconds.

Implements juce::AudioProcessor.

References getTailLengthSeconds().

Referenced by getTailLengthSeconds().

## acceptsMidi()

bool juce::AudioProcessorGraph::acceptsMidi | ( |  | ) | const

override virtual

Returns true if the processor wants MIDI messages.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

Implements juce::AudioProcessor.

References acceptsMidi().

Referenced by acceptsMidi().

## producesMidi()

bool juce::AudioProcessorGraph::producesMidi | ( |  | ) | const

override virtual

Returns true if the processor produces MIDI messages.

This must return the same value every time it is called. This may be called by the audio thread, so this should be fast. Ideally, just return a constant.

Implements juce::AudioProcessor.

References producesMidi().

Referenced by producesMidi().

## hasEditor()

bool juce::AudioProcessorGraph::hasEditor | ( |  | ) | const

inline override virtual

Your processor subclass must override this and return true if it can create an editor component.

See also
  createEditor

Implements juce::AudioProcessor.

References hasEditor().

Referenced by hasEditor().

## createEditor()

AudioProcessorEditor * juce::AudioProcessorGraph::createEditor | ( |  | ) |

inline override virtual

Creates the processor's GUI.

This can return nullptr if you want a GUI-less processor, in which case the host may create a generic UI that lets the user twiddle the parameters directly.

If you do want to pass back a component, the component should be created and set to the correct size before returning it. If you implement this method, you must also implement the hasEditor() method and make it return true.

Remember not to do anything like allowing your processor to keep a pointer to the component that gets created - it could be deleted later without any warning, which would make your pointer into a dangler. Use the getActiveEditor() method instead.

The correct way to handle the connection between an editor component and its processor is to use something like a ChangeBroadcaster so that the editor can register itself as a listener, and be told when a change occurs. This lets them safely unregister themselves when they are deleted.

Here are a few things to bear in mind when writing an editor:

- Initially there won't be an editor, until the user opens one, or they might not open one at all. Your processor mustn't rely on it being there.
- An editor object may be deleted and a replacement one created again at any time.
- It's safe to assume that an editor will be deleted before its processor.

See also
  hasEditor

Implements juce::AudioProcessor.

## getNumPrograms()

int juce::AudioProcessorGraph::getNumPrograms | ( |  | ) |

inline override virtual

Returns the number of preset programs the processor supports.

The value returned must be valid as soon as this object is created, and must not change over its lifetime.

This value shouldn't be less than 1.

Implements juce::AudioProcessor.

## getCurrentProgram()

int juce::AudioProcessorGraph::getCurrentProgram | ( |  | ) |

inline override virtual

Returns the number of the currently active program.

Implements juce::AudioProcessor.

## setCurrentProgram()

void juce::AudioProcessorGraph::setCurrentProgram | ( | int | index | ) |

inline override virtual

Called by the host to change the current program.

Implements juce::AudioProcessor.

## getProgramName()

const String juce::AudioProcessorGraph::getProgramName | ( | int | index | ) |

inline override virtual

Must return the name of a given program.

Implements juce::AudioProcessor.

## changeProgramName()

void juce::AudioProcessorGraph::changeProgramName | ( | int | index,
|  | const String & | newName )

inline override virtual

Called by the host to rename a program.

Implements juce::AudioProcessor.

## getStateInformation()

void juce::AudioProcessorGraph::getStateInformation | ( | juce::MemoryBlock & | destData | ) |

override virtual

The host will call this method when it wants to save the processor's internal state.

This must copy any info about the processor's state into the block of memory provided, so that the host can store this and later restore it using setStateInformation().

Note that there's also a getCurrentProgramStateInformation() method, which only stores the current program, not the state of the entire processor.

See also the helper function copyXmlToBinary() for storing settings as XML.

See also
  getCurrentProgramStateInformation

Implements juce::AudioProcessor.

## setStateInformation()

void juce::AudioProcessorGraph::setStateInformation | ( | const void * | data,
|  | int | sizeInBytes )

override virtual

This must restore the processor's state from a block of data previously created using getStateInformation().

Note that there's also a setCurrentProgramStateInformation() method, which tries to restore just the current program, not the state of the entire processor.

See also the helper function getXmlFromBinary() for loading settings as XML.

In the case that this AudioProcessor is implementing a VST3 that has declared compatible plugins via JUCE_VST3_COMPATIBLE_CLASSES, the state passed to this function may have been created by one of these compatible plugins.

If the parameter IDs of the current plugin differ from the IDs of the plugin whose state was passed to this function, you can use information from the plugin state to determine which parameter mapping to use if necessary. VST3ClientExtensions::getCompatibleParameterIds() will always be called after setStateInformation(), and that function should return the parameter mapping from the most recently-loaded state.

See also
  setCurrentProgramStateInformation, VST3ClientExtensions::getCompatibleParameterIds

Implements juce::AudioProcessor.

References AudioProcessorGraph().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited